Add shell flags and set long options

This commit is contained in:
gardouille 2023-01-24 18:30:20 +01:00
parent 9976ad1144
commit f8f50b4745
Signed by: gardouille
GPG Key ID: E759BAA22501AF32
1 changed files with 32 additions and 13 deletions

View File

@ -7,12 +7,29 @@
# #
# !!DATE!! # !!DATE!!
# }}} # }}}
# Flags {{{
## Exit on error {{{
set -o errexit
## }}}
## Exit on unset var {{{
### Use "${VARNAME-}" to test a var that may not have been set
set -o nounset
## }}}
## Pipeline command is treated as failed {{{
### Not available in POSIX sh https://github.com/koalaman/shellcheck/wiki/SC3040
#set -o pipefail
## }}}
## Help with debugging {{{
### Call the script by prefixing it with "TRACE=1 ./script.sh"
if [ "${TRACE-0}" -eq 1 ]; then set -o xtrace; fi
## }}}
# }}}
# Vars {{{ # Vars {{{
PROGNAME=$(basename "${0}"); readonly PROGNAME PROGNAME=$(basename "${0}"); readonly PROGNAME
PROGDIR=$(readlink -m $(dirname "${0}")); readonly PROGDIR PROGDIR=$(readlink --canonicalize-missing $(dirname "${0}")); readonly PROGDIR
ARGS="${*}"; readonly ARGS ARGS="${*}"; readonly ARGS
readonly NBARGS="${#}" readonly NBARGS="${#}"
[ -z "${DEBUG}" ] && DEBUG=1 [ -z "${DEBUG-}" ] && DEBUG=1
## Export DEBUG for sub-script ## Export DEBUG for sub-script
export DEBUG export DEBUG
@ -43,7 +60,6 @@ OPTIONS:
-h,--help -h,--help
Print this help message. Print this help message.
HELP HELP
} }
# }}} # }}}
debug_message() { # {{{ debug_message() { # {{{
@ -64,7 +80,9 @@ error_message() { # {{{
local_error_code="${2}" local_error_code="${2}"
## Print message ## Print message
printf '%b\n' "ERROR ${PROGNAME}: ${RED}${local_error_message}${RESET}" printf '%b\n' "ERROR ${PROGNAME}: ${RED}${local_error_message}${RESET}" >&2
unset local_error_message
exit "${local_error_code:=66}" exit "${local_error_code:=66}"
} }
@ -72,13 +90,12 @@ error_message() { # {{{
define_vars() { # {{{ define_vars() { # {{{
## If my_var_xy wasn't defined (argument) {{{ ## If my_var_xy wasn't defined (argument) {{{
#if [ -z "${my_var_xy}" ]; then #if [ -z "${my_var_xy-}" ]; then
### Use default value ### Use default value
#readonly my_var_xy="${MY_VAR_XY_DEFAULT}" #readonly my_var_xy="${MY_VAR_XY_DEFAULT}"
#fi #fi
## }}} ## }}}
true; ## Remove me true; ## Remove me
} }
# }}} # }}}
@ -108,8 +125,15 @@ if [ ! "${NBARGS}" -eq "0" ]; then
manage_arg="0" manage_arg="0"
## If the first argument ask for help (h|help|-h|-help|-*h|-*help) {{{
if printf -- '%s' "${1-}" | grep --quiet --extended-regexp -- "^-*h(elp)?$"; then
usage
exit 0
fi
## }}}
## If the first argument is not an option ## If the first argument is not an option
if ! printf -- '%s' "${1}" | grep -q -E -- "^-+"; if ! printf -- '%s' "${1}" | grep --quiet --extended-regexp -- "^-+";
then then
## Print help message and exit ## Print help message and exit
printf '%b\n' "${RED}Invalid option: ${1}${RESET}" printf '%b\n' "${RED}Invalid option: ${1}${RESET}"
@ -120,18 +144,13 @@ if [ ! "${NBARGS}" -eq "0" ]; then
fi fi
# Parse all options (start with a "-") one by one # Parse all options (start with a "-") one by one
while printf -- '%s' "${1}" | grep -q -E -- "^-+"; do while printf -- '%s' "${1-}" | grep --quiet --extended-regexp -- "^-+"; do
case "${1}" in case "${1}" in
-d|--debug ) ## debug -d|--debug ) ## debug
DEBUG=0 DEBUG=0
debug_message "--- Manage argument BEGIN" debug_message "--- Manage argument BEGIN"
;; ;;
-h|--help ) ## help
usage
## Exit after help informations
exit 0
;;
#-v|--var ) ## Define var with given arg #-v|--var ) ## Define var with given arg
### Move to the next argument ### Move to the next argument
#shift #shift